Con

''Prop Invaders Rev.(P)

'=======Set as Needed=========================================================

'Note: This would be easier if you could store type in EEPROM...

   Demo      = true                   ' Demo Board
   Proto     = false                  ' Proto Board
   Hydra     = false                  ' Hydra
'=============================================================================

_clkmode  = xtal1 + ((Hydra & pll8x) | ((Demo | Proto) & pll16x))
_xinfreq  = (Hydra & 10_000_000) | ((Demo | Proto) & 5_000_000)

   dspPins   = (Hydra & 24) | ((Demo | Proto) & 12)   ' TV
   keyPins   = (Hydra & 13) | ((Demo | Proto) & 26)   ' Keyboard
 soundPins   = (Hydra & 7)  | ((Demo | Proto) & 10)   ' Sound


Obj
 Key : "ComboKeyboard"
 TV  : "AIGeneric_Driver"
 Snd : "Sound"

Var
Byte Err, hit[12] 
Byte X, Y , Firex[10], Firey[10], fire[10], ax, sound
Byte alien[20], alx[20], aly[20]
word score 
Pub Start | okayK, okayT, okayS , I , L, k, a
TV.Start(dspPins)                                              'Start TV Driver
okayK := Key.start(KeyPins)                                    'Start Keyboard Driver
okayS := snd.start(soundPins)                                  'Start Sound Driver
if OkayK < 0                                                   'If Keyboard Driver doesn't boot, Uh-Oh!
 Err := 1
  Error                                                        'set for sound
sound := 1
repeat
 OkayK := Key.present
until OkayK == true                                             'If all goes well, start the game
'========================Start===========================================
 tv.sel(24, 0)
 repeat 39
  tv.out($09)
 tv.sel(25, 0)
 tv.sel(25, 0)
 tv.str(string(" Propeller Invaders       "))
 scoring
Shield
Fire[0] := 0
repeat 
 movSS
 checkey
 scoring 
 repeat I from 0 to 10                                           'Move aliens right 
  tv.sel(ax, I)                                                  'If I = a even #, show 2nd alien,
  repeat a from 1 to 10                                          'creating a moving effect
   if I == 0 or I == 2 or I == 4  or I == 6  or I == 8 or I == 10
    if alien[a] == 0                        
      Tv.str(string(" ",$04+2," "))
    else
      Tv.str(string(" "," "," "))
    alx[a] := ax
    aly[a] := I       
   else
    alx[a] := ax
    aly[a] := I
    if alien[a] == 0
      Tv.str(string(" ",$04," "))
    else
      Tv.str(string(" "," "," "))
     

  checkey

  scoring         
  Tv.str(string(13))                
  tv.sel(ax+2, I)                      
  repeat a from 11 to 20
   if I == 0 or I == 2 or I == 4  or I == 6  or I == 8 or I == 10
    if alien[a] == 0                         
      Tv.str(string(" ",$05+2," "))
    else
      Tv.str(string(" "," "," "))
    alx[a] := ax+2
    aly[a] := I   
   else
    alx[a] := ax+2
    aly[a] := I 
    if alien[a] == 0  
      Tv.str(string(" ",$05," "))
    else
      Tv.str(string(" "," "," "))
  checkey
  scoring     
  waitcnt(30000000/2 + cnt)
  if sound ==1
   Snd.freq(200000, 200000, 5)
  checkey
  scoring
          
  waitcnt(30000000/2 + cnt)
  checkey
  scoring                                  
 repeat I from 10 to 0                                           'Move aliens left  
  tv.sel(ax, I)                                                  'If I = a even #, show 2nd alien,
  repeat a from 1 to 10                                          'creating a moving effect
   if I == 0 or I == 2 or I == 4  or I == 6  or I == 8 or I == 10
    if alien[a] == 0                        
      Tv.str(string(" ",$04+2," "))
    else
      Tv.str(string(" "," "," "))
    alx[a] := ax
    aly[a] := I       
   else
    alx[a] := ax
    aly[a] := I
    if alien[a] == 0
      Tv.str(string(" ",$04," "))
    else
      Tv.str(string(" "," "," "))
  
          
  checkey         
  scoring
         
  Tv.str(string(13))                
  tv.sel(ax+2, I)                      
  repeat a from 11 to 20
   if I == 0 or I == 2 or I == 4  or I == 6  or I == 8 or I == 10
    if alien[a] == 0                         
      Tv.str(string(" ",$05+2," "))
    else
      Tv.str(string(" "," "," "))
    alx[a] := ax+2
    aly[a] := I   
   else
    alx[a] := ax+2
    aly[a] := I 
    if alien[a] == 0  
      Tv.str(string(" ",$05," "))
    else
      Tv.str(string(" "," "," "))
  checkey
  scoring
  waitcnt(30000000/2 + cnt)
  if sound == 1
   Snd.freq(200000, 200000, 5)  
  checkey
  scoring 
  waitcnt(30000000/2 + cnt)  
  checkey
  scoring
 
                     
 tv.out($00)
  
 tv.sel(24, 0)
 repeat 39
  tv.out($09)
 tv.sel(25, 0)      
 tv.str(string(" Propeller Invaders       "))
 scoring  
 ax++                                                
Pub Error
abort
Pub checkey | k

k := key.peekkey
if k > 0
 k := key.getkey
 if k == 193             'right
 
   x := x + 1 <#37
   movSS     
 elseif k == 192         'left
   x:= x - 1 #>2
   
   movSS
 elseif k == $20
           'space
  ifnot fire[0] == 1
   if sound
    Snd.freq(1000, 100000, 2000) 
   firey[0] := 21
   firex[0] := (x + 1)
    fire[0] := 1
 else
  !sound 
  
Pub movSS

tv.sel(22, x)
tv.str(string(" ",$03," "))
Pub Gameover | k
tv.out($00)
repeat 29
 tv.out($04)
tv.out(13)
tv.str(string($04, "         GAME OVER         ", $04,13))
repeat 29
 tv.out($04)
repeat
 tv.out($00)
 repeat 29
  tv.out($04+2)
 tv.out(13)
 tv.str(string($04, "         GAME OVER         ", $04,13))
 repeat 29
  tv.out($04+2)
 waitcnt(30000000 + cnt)
 tv.out($00) 
 repeat 29
  tv.out($04)
 tv.out(13)
 tv.str(string($04, "         GAME OVER         ", $04,13))
 repeat 29
  tv.out($04)
 waitcnt(30000000 + cnt)
 K := key.peekkey
 if K > 0
  reboot
Pub scoring | m 
tv.sel(24, 23)
score := 0
repeat m from 0 to 20
 score += alien[m] * 10
tv.str(string("SCORE: "))
tv.dec(score)
'tv.dec(ax)    '  debug purposes
Win
MovF
Shield
Pub Win  | a, g
repeat a from 1 to 20
 if alien[a] == 1
   G++
   
if g == 20
 tv.out($00)
 Tv.str(string(" You Win!"))
 abort
else
 g := 0

Pub MovF | l2 
repeat l2 from 0 to 10  
  if fire[l2] == 1 
   tv.sel(firey[l2], firex[l2])
   tv.out($0C)
   ifnot firey[l2] == 21
    tv.sel(firey[l2]+1, firex[l2])    
     tv.out(" ")
   firey[l2] := (firey[l2] - 1 #>0) 
   if firey[l2] == 0
    tv.sel((firey[l2]+ 1), firex[l2])
    tv.out(" ")
    fire[l2] := 0
  
Pub Shield
tv.sel(21,7)
if hit[0] == 0         
 tv.out($0A)
 tv.out($1E)
 tv.out($1E)    
 tv.out($0B)
elseif hit[0] == 1
 tv.out($1B) 
 tv.out($1D)                    
 tv.out($1D) 
 tv.out($1C)             
elseif hit[0] == 2
 tv.out($19) 
 tv.out(" ")
 tv.out(" ") 
 tv.out($1A)
elseif hit[0] == 3
 tv.out(" ") 
 tv.out(" ")                   
 tv.out(" ") 
 tv.out($1A)
elseif hit[0] == 4
 tv.out($19) 
 tv.out(" ")
 tv.out(" ")
 tv.out(" ")
elseif hit[0] == 5
 tv.out($1F) 
 tv.out($7E)                    
 tv.out(" ") 
 tv.out(" ")   


tv.sel(21,14)
if hit[1] == 0         
 tv.out($0A)
 tv.out($1E)
 tv.out($1E)    
 tv.out($0B)
elseif hit[1] == 1
 tv.out($1B) 
 tv.out($1D)                    
 tv.out($1D) 
 tv.out($1C)             
elseif hit[1] == 2
 tv.out($19) 
 tv.out(" ")
 tv.out(" ") 
 tv.out($1A)
elseif hit[1] == 3
 tv.out(" ") 
 tv.out(" ")
 tv.out(" ")  
 tv.out($1A)
elseif hit[1] == 4
 tv.out($19) 
 tv.out(" ")
 tv.out(" ") 
 tv.out(" ")
elseif hit[1] == 5
 tv.out(" ") 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out(" ")    

tv.sel(21,21)
if hit[2] == 0         
 tv.out($0A)
 tv.out($1E)
 tv.out($1E)    
 tv.out($0B)
elseif hit[2] == 1
 tv.out($1B) 
 tv.out($1D)                    
 tv.out($1D) 
 tv.out($1C)             
elseif hit[2] == 2
 tv.out($19) 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out($1A)
elseif hit[2] == 3
 tv.out(" ") 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out($1A)
elseif hit[2] == 4
 tv.out($19) 
 tv.out(" ")
 tv.out(" ") 
 tv.out(" ")
elseif hit[2] == 5
 tv.out(" ") 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out(" ")   

tv.sel(21,28)
if hit[3] == 0         
 tv.out($0A)
 tv.out($1E)
 tv.out($1E)    
 tv.out($0B)
elseif hit[3] == 1
 tv.out($1B) 
 tv.out($1D)                    
 tv.out($1D) 
 tv.out($1C)             
elseif hit[3] == 2
 tv.out($19) 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out($1A)
elseif hit[3] == 3
 tv.out(" ") 
 tv.out(" ")                  
 tv.out(" ") 
 tv.out($1A)
elseif hit[3] == 4
 tv.out($19) 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out(" ")
elseif hit[3] == 5
 tv.out(" ") 
 tv.out(" ")                    
 tv.out(" ") 
 tv.out(" ")

    